package gregapi.block.metatype;

import static gregapi.data.CS.SIDE_TOP;
import static gregapi.data.CS.T;
import static gregapi.data.CS.TOOL_LOCALISER_PREFIX;
import gregapi.block.BlockBase;
import gregapi.data.LH;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.IIcon;
import net.minecraft.world.World;

public class ItemBlockMeta extends ItemBlock {
	public final BlockBase mPlaceable;
	
	public ItemBlockMeta(Block aBlock) {
		super(aBlock);
		mPlaceable = (BlockBase)aBlock;
		setMaxDamage(0);
		setHasSubtypes(T);
		setCreativeTab(CreativeTabs.tabBlock);
	}
	
	@Override
	public void addInformation(ItemStack aStack, EntityPlayer aPlayer, List aList, boolean aF3_H) {
		super.addInformation(aStack, aPlayer, aList, aF3_H);
		int aMeta = UT.Stacks.meta(aStack);
		mPlaceable.addInformation(aStack, aMeta, aPlayer, aList, aF3_H);
		if (!mPlaceable.canCreatureSpawn(aMeta) && mPlaceable.getCollisionBoundingBoxFromPool(aPlayer.worldObj, 0, 0, 0) != null) aList.add(LH.Chat.CYAN + LH.get(LH.TOOLTIP_SPAWNPROOF));
		aList.add(LH.Chat.WHITE + LH.get(LH.TOOLTIP_BLASTRESISTANCE) + LH.Chat.ORANGE + mPlaceable.getExplosionResistance(aMeta));
		aList.add(LH.Chat.DGRAY + LH.get(LH.TOOL_TO_HARVEST) + ": " + LH.Chat.WHITE + LH.get(TOOL_LOCALISER_PREFIX + mPlaceable.getHarvestTool(aMeta), "Unknown") + " (" + mPlaceable.getHarvestLevel(aMeta) + ")");
	}
	
	@Override public IIcon getIconFromDamage(int aMeta) {return mPlaceable.getIcon(SIDE_TOP, aMeta);}
	@Override public String getUnlocalizedName(ItemStack aStack) {return mPlaceable.mNameInternal + "." + getDamage(aStack);}
	@Override public boolean placeBlockAt(ItemStack aStack, EntityPlayer aPlayer, World aWorld, int aX, int aY, int aZ, int aSide, float aHitX, float aHitY, float aHitZ, int aMetaData) {return aWorld.setBlock(aX, aY, aZ, mPlaceable, aMetaData, 3);}
	@Override public int getItemStackLimit(ItemStack aStack) {return mPlaceable.getItemStackLimit(aStack);}
	@Override public int getMetadata(int aMeta) {return aMeta;}
}