package gregapi.block.rail;

import static gregapi.data.CS.T;
import static gregapi.data.CS.TOOL_LOCALISER_PREFIX;
import static gregapi.data.CS.W;
import gregapi.data.LH;
import gregapi.util.UT;

import java.util.List;

import net.minecraft.block.Block;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;

public class ItemBlockBaseRail extends ItemBlock {
	public final BlockBaseRail mPlaceable;
	
    public ItemBlockBaseRail(Block aBlock) {
        super(aBlock);
        mPlaceable = (BlockBaseRail)aBlock;
        setMaxDamage(0);
        setHasSubtypes(T);
        setCreativeTab(CreativeTabs.tabBlock);
    }
    
    @Override
    public void addInformation(ItemStack aStack, EntityPlayer aPlayer, List aList, boolean aF3_H) {
    	super.addInformation(aStack, aPlayer, aList, aF3_H);
		int aMeta = UT.Stacks.meta(aStack);
    	mPlaceable.addInformation(aStack, aMeta, aPlayer, aList, aF3_H);
		aList.add(LH.Chat.CYAN + LH.get(LH.TOOLTIP_RAILSPEED) + LH.Chat.GREEN + (mPlaceable.mSpeed/0.4F) + "x");
		if (!mPlaceable.canCreatureSpawn(aMeta)) aList.add(LH.Chat.CYAN + LH.get(LH.TOOLTIP_SPAWNPROOF));
		aList.add(LH.Chat.WHITE + LH.get(LH.TOOLTIP_BLASTRESISTANCE) + LH.Chat.ORANGE + mPlaceable.getExplosionResistance(aMeta));
    	aList.add(LH.Chat.DGRAY + LH.get(LH.TOOL_TO_HARVEST) + ": " + LH.Chat.WHITE + LH.get(TOOL_LOCALISER_PREFIX + mPlaceable.getHarvestTool(aMeta), "Unknown") + " (" + mPlaceable.getHarvestLevel(aMeta) + ")");
    }
    
    @Override public String getUnlocalizedName(ItemStack aStack) {return mPlaceable.mNameInternal + (getDamage(aStack)==W?"."+W:"");}
    @Override public boolean placeBlockAt(ItemStack aStack, EntityPlayer aPlayer, World aWorld, int aX, int aY, int aZ, int aSide, float aHitX, float aHitY, float aHitZ, int aMetaData) {return aWorld.setBlock(aX, aY, aZ, mPlaceable, aMetaData, 3);}
	@Override public int getItemStackLimit(ItemStack aStack) {return mPlaceable.getItemStackLimit(aStack);}
    @Override public int getMetadata(int aMeta) {return 0;}
}